<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

require_once("config.php");
require_once("user/protect.php");
require_once("user/user-lib.php");
$add2=0;
if (file_exists("add2.php")){
	require_once("add2.php");
}
@set_time_limit(3000);
@ini_set('max_execution_time', 900);

$db = new PDO(
      "mysql:host=".USER_DB_HOST.";dbname=".USER_DB_NAME.";charset=".USER_DB_CHARSET,
      USER_DB_USER, USER_DB_PASSWORD, [
      PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
      PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC
    ]);

if ($masterkeymode==false) {
	$query = "SELECT user_apikey FROM users WHERE user_id = :userid";
	$statement = $db->prepare($query);
	$statement->bindParam(':userid', $userid);
	$statement->execute();
	$result = $statement->fetch(PDO::FETCH_ASSOC);
	if ($result && !empty($result['user_apikey'])) {
		$api_key = $result['user_apikey'];
	} else {
		echo "NOUSERKEY";
		exit();
	}
} else {
	$api_key = $masterapikey;
}


// Check for credits system and set key accordingly

if ($add2==1){
	$api_key = $masterapikey;
}

$postfields = array();
foreach ($_POST as $key => $value) {
    $postfields[$key] = $value;
	$postfields[$key]=str_replace("'","",$postfields[$key]);
	$postfields[$key]=addslashes($postfields[$key]);			
}

$toneoptions = array(
	"1" => "Authoritative",
	"2" => "Casual",
	"3" => "Confident",
	"4" => "Conversational",
	"5" => "Educational",
	"6" => "Empathetic",
	"7" => "Encouraging",
	"8" => "Enthusiastic",
	"9" => "Friendly",
	"10" => "Informative",
	"11" => "Lighthearted",
	"12" => "Optimistic",
	"13" => "Persuasive",
	"14" => "Professional",
	"15" => "Straightforward",
	"16" => "Technical"
);
$tone="";
$tonenumber=$postfields["tone"];
if (isset($toneoptions[$tonenumber])) {
	$tone = $toneoptions[$tonenumber];
} 
$langoptions = [
    "1" => "Chinese",
    "2" => "Dutch",
    "3" => "English",
    "4" => "French",
    "5" => "German",
    "6" => "Italian",
    "7" => "Japanese",
    "8" => "Korean",
    "9" => "Portuguese",
    "10" => "Russian",
    "11" => "Spanish",
    "12" => "Vietnamese"
];
$language="";
$langnumber=$postfields["language"];
if (isset($langoptions[$langnumber])) {
	$language = $langoptions[$langnumber];
}

$panel_input=$postfields["panel_input"];

$target_audience=trim($postfields["audience"]);

$audience_insert="Throughout this task, infuse your writing with the chosen tone: [".$tone."]. Maintain a professional demeanor, eliminating any self-references, apologies, reminders about the instructions, or expressions of gratitude. Refrain from any self-referential remarks. Do not repeat back any of this prompt in your output.";
if($target_audience!==""){
	$audience_insert="Throughout this task, infuse your writing with the chosen tone: [".$tone."] to establish a connection with the target audience of: [".$target_audience."]. Maintain a professional demeanor, eliminating any self-references, apologies, reminders about the instructions, or expressions of gratitude. Refrain from any self-referential remarks. Do not repeat back any of this prompt in your output.";
}

if (isset($postfields["stype"])){
	
	switch ($postfields["stype"]) {
		
		case "1": // FB Personal Post
			
			$prompt="Please write a Facebook post for a personal Facebook timeline centered around the subject of [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		case "2": // FB Business Post
			
			$prompt="Please write a Facebook post for a business Facebook timeline centered around the subject of [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		case "3": // FB Ad
			
			$prompt="Please write a Facebook ad for the subject of [".$postfields["panel_input"]."]. Make sure it will engage with my audience and deliver a high click through rate. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		case "4": // FB Audience
			 
			$prompt="My Facebook account is about [".$postfields["panel_input"]."]. Please tell me what my audience is like. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		case "5": // FB Growth Strategy
			 
			$prompt="My Facebook account is about [".$postfields["panel_input"]."]. I want to build a growth strategy for this account - please give an actionable strategy plan. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;			

		case "6": // YT Descriptions
			 
			$prompt="Generate descriptions for a YouTube video about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;			

		case "7": // YT Titles
			 
			$prompt="Generate titles for a YouTube video about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "8": // YT Tags
			 
			$prompt="Generate tags for a YouTube video about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "9": // YT Script
			 
			$prompt="Generate an engaging script for a YouTube video about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "10": // YT Growth Strategy
			 
			$prompt="My YouTube Channel is about [".$postfields["panel_input"]."]. I want to build a growth strategy for this YouTube Channel - please give an actionable strategy plan. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "11": // YT Ad Script
			 
			$prompt="Generate an engaging script for a YouTube ad about [".$postfields["panel_input"]."]. This script should be engaging and designed to deliver high click through. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "12": // TikTok Video Script
			 
			$prompt="Generate an engaging video script for my TikTok account about [".$postfields["panel_input"]."]. This script should be designed for maximum engagement. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "13": // TikTok Hashtags
			 
			$prompt="Generate an TikTok hashtags for my TikTok video about [".$postfields["panel_input"]."]. These hashtags should be relevant to my audience demographic. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "14": // TikTok Titles
			 
			$prompt="Generate titles for my TikTok video about [".$postfields["panel_input"]."]. These titles should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "15": // TikTok Descriptions
			 
			$prompt="Generate descriptions for my TikTok video about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "16": // TikTok Growth Strategy
			 
			$prompt="My TikTok Account is about [".$postfields["panel_input"]."]. I want to build a growth strategy for this TikTok Account - please give an actionable strategy plan. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "17": // TikTok Ads
			 
			$prompt="Generate an engaging script for a TikTok ad about [".$postfields["panel_input"]."]. This script should be engaging and designed to deliver high click through. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "18": // LinkedIn Posts
			 
			$prompt="Generate an engaging and professional LinkedIn post that will help my companies profile for my LinkedIn account about [".$postfields["panel_input"]."]. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "19": // LinkedIn Ads
			 
			$prompt="Generate a professional and engaging LinkedIn Ad that will sell my service on my LinkedIn account about [".$postfields["panel_input"]."]. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "20": // LinkedIn Hashtags
			 
			$prompt="Generate a professional and engaging set of LinkedIn hashtags for a LinkedIn Ad that will sell my service on my LinkedIn account about [".$postfields["panel_input"]."]. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "21": // LinkedIn Articles
			 
			$prompt="Generate a professional and engaging article for LinkedIn for my LinkedIn account about [".$postfields["panel_input"]."]. This article should be professional in nature and should resonate with my target audience demographic. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "22": // Pinterest Ads
			 
			$prompt="Tell me what the perfect image ad would be for Pinterest where my Pinterest account is about [".$postfields["panel_input"]."]. The image should deliver high click throughs. This should resonate with my target audience demographic. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "23": // Pinterest Ideas
			 
			$prompt="Generate ideas for engaging Pinterest Pins for  my Pinterest account which is about [".$postfields["panel_input"]."]. This should resonate with my target audience demographic. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "24": // Pinterest Descriptions
			 
			$prompt="Generate a description for my Pinterest Pin for my Pinterest account which is about [".$postfields["panel_input"]."]. This should resonate with my target audience demographic. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "25": // Pinterest Growth Strategy
			 
			$prompt="My Pinterest Account is about [".$postfields["panel_input"]."]. I want to build a growth strategy for this Pinterest Account - please give an actionable strategy plan. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "26": // Instagram Ideas
			 
			$prompt="Generate some ideas on what content to create to help me grow my Instagram Account which is about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "27": // Instagram Personal Post
			 
			$prompt="Generate a post for my personal Instagram Account which is about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  Also tell me what Image I could include with the post. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "28": // Instagram business Post
			 
			$prompt="Generate a post for my business Instagram Account which is about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  Also tell me what Image I could include with the post. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "29": // Instagram Ads
			 
			$prompt="Generate a video script for an Instgram Ad for my Instagram Account which is about [".$postfields["panel_input"]."]. The script should deliver high click throughs. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "30": // Instagram Reel
			 
			$prompt="Generate a video script for an Instagram Reel for my Instagram Account which is about [".$postfields["panel_input"]."]. The script should deliver high click throughs. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "31": // Instagram Growth Strategy
			 
			$prompt="My Instagram Account is about [".$postfields["panel_input"]."]. I want to build a growth strategy for this Instagram Account - please give an actionable strategy plan. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "32": // Twitter/X post
			 
			$prompt="Generate an engaging tweet for my Twitter Account which is about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."].".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "33": // Twitter/X hashtags
			 
			$prompt="Generate hashtags for my Twitter Account which is about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "34": // Twitter/X Ad
			 
			$prompt="Generate a Twitter Ad for my Twitter Account which is about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."].".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		case "35": // Twitter/X Growth Strategy
			 
			$prompt="My Twitter Account is about [".$postfields["panel_input"]."]. I want to build a growth strategy for this Twitter Account - please give an actionable strategy plan. This information should be written in the language [".$language."]. ".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "36": // Reddit post
			 
			$prompt="Generate an engaging post for Reddit which is about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."].".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		case "37": // Reddit story
			 
			$prompt="Generate an engaging story for Reddit about [".$postfields["panel_input"]."]. It should be relevant to my audience demographic and engaging.  This information should be written in the language [".$language."].".$audience_insert;
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		default :
			echo "UNKNOWN MODE";
			break;	
	}
	exit();
} else {
	echo ("NOMODE");
	exit();
}


function sendPrompt($prompt,$aiengine,$api_key){
	$endpoint="chat/completions";
	$modelname="gpt-3.5-turbo-16k";
	$aiengine=0; 
	if ($aiengine==0) {
		$endpoint="chat/completions";
		$modelname="gpt-3.5-turbo-16k";
	} else if ($aiengine==1) {
		$endpoint="chat/completions";
		$modelname="gpt-4";		
	}
	$modelname = "gpt-4o-mini"; // Default model name
	$curl = curl_init();
	curl_setopt_array($curl, array(
	  CURLOPT_URL => 'https://api.openai.com/v1/'.$endpoint,
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => '',
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 0,
	  CURLOPT_FOLLOWLOCATION => true,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => 'POST',
	  CURLOPT_POSTFIELDS =>'{"model":"'.$modelname.'","messages": [{"role": "user", "content": "'.$prompt.'"}],"temperature":1,"max_tokens":14000}',
	  CURLOPT_HTTPHEADER => array(
		'Authorization: Bearer '.$api_key,
		'Content-Type: application/json'
	  ),
	));
	$response = curl_exec($curl);
	if ($response===false){
		echo "APIERROR - ".curl_error($curl);
		curl_close($curl);
		exit();
	} else {
		if (isset($response['error']) && $response['status'] != 200) {
			//header("HTTP/1.1 500 Internal Server Error");
			print_r($response);
		} else {
			print_r($response);
		}		
		curl_close($curl);
		exit();
	}
	
}


?>
